package fi.em.formPlugin;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import org.apache.commons.io.FileUtils;
import sys.sc.opplugin.utils.InterFaceImgUtils;
import sys.sc.opplugin.utils.SftpClient;

import javax.swing.filechooser.FileSystemView;
import java.io.File;

/**
 * @author cjz
 * @date 2024/11/7 20:35
 * @description:点击按钮下载对应薪酬计提分录模板文件
 */
public class SalaryDownloadFilePlugin extends AbstractFormPlugin {



    //点击按钮下载文件
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs arg){
        super.afterDoOperation(arg);
        String operateKey = arg.getOperateKey();
        //审核操作代码
        String downloadBut="download";
        DynamicObject dynamicObject=this.getModel().getDataEntity(true);
        String nckd_entrytype= dynamicObject.getString("nckd_entrytype");
        if (downloadBut.equals(operateKey)) {
            //通用薪酬(一般员工)
            downFileToLocal(nckd_entrytype);
        }
    }

    //根据分录类型，下载对应的分录模板
    public void downFileToLocal(String nckd_entrytype) {
        //获取下拉列表字段
        ComboProp comboProp = (ComboProp) getModel().getProperty("nckd_entrytype");
        try {
            //获取文件上传接口配置信息
            InterFaceImgUtils interFaceImgUtils=new InterFaceImgUtils("downloadurl");
            //端口号
            int port= interFaceImgUtils.getPort();
            //服务器地址
            String serverurl= interFaceImgUtils.getServerName();
            //用户
            String user= interFaceImgUtils.getServerUser();
            //密码
            String password= interFaceImgUtils.getServerPassword();
            //文件名
            String filename= interFaceImgUtils.getFileName();
            //获取文件路径
            String fileurl= interFaceImgUtils.getServerUrl();
            //文件保存路径
            String fileLocalpath= interFaceImgUtils.getFileLocalPath();
            //通过下拉值获取下拉标题
            String displayName = comboProp.getItemByName(nckd_entrytype);
            //文件服务器路径
            String filepath=fileurl+"/"+nckd_entrytype+".xls";
            //获取sftp链接对象
            SftpClient sftpClient=new SftpClient(serverurl,user,password,port);
            //获取服务器链接
            sftpClient.connect();
            sftpClient.downloadFile(filepath,fileLocalpath+File.separator+displayName+filename);
            sftpClient.disconnect();
            this.getView().showMessage("文件下载成功，文件位置："+fileLocalpath+File.separator+displayName+filename);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
